let prefs={};

var msgs;
var wid;
var msgCount;
var sending=false;

function validate(elem) {
  const re=/^(?:.*<)?(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9]))\.){3}(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9])|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])>?$/i;
  let address=elem.value;
  if (!address) {
    elem.className='empty';
  } else if (re.test(address)) {
    elem.className='valid';
  } else {
    elem.className='invalid';
  }
  let i=document.getElementsByClassName('invalid').length;
  let v=document.getElementsByClassName('valid').length;
  if (i || !v)
    document.getElementById('addressOK').disabled=true;
  else
    document.getElementById('addressOK').disabled=false;
}

async function okAndInput(ev) {
  if (ev.repeat) {
//debug('key repeated');
    return;
  }
	if (ev.type == "keydown") {
    let sel=document.getElementById('results');
    if (ev.key == "Enter") {
      if (sel) sel.parentNode.removeChild(sel);
      if (ev.target.value) {
        newInput(ev.target);
        validate(ev.target);
      }
    } else if (ev.key=='ArrowDown' || ev.key=='Tab') {
//debug('key down');
      if (sel) {
        sel.focus();
        sel.firstChild.selected=true;
        ev.preventDefault();  //else sel scrolls
      }
    } else if (ev.key == "Escape") {
//debug('cancel (Escape)');
			removeWin();
    }
	}

}

async function send(ev) {
debug('sending messages wid='+wid);
  let addresses=[];
  let add=document.getElementById("addresses");
  if (add.value) addresses.push(add.value);
  while ((add=add.nextSibling)) {
    if (add.value) addresses.push(add.value);
  }
  if (!addresses.length || !msgs.length) {
    debug('no addresses or no messages');
    return;
  }
  msgs.forEach(msg=>{
    msg.sending=true;
debug('msg: '+msg.subject)
  });
addresses.forEach(add=>debug('addr: '+add));
  messenger.smr.redirect(msgs, addresses, wid, prefs);
  sending=true;
  msgCount=msgs.length;
debug('send done');
  ev.target.disabled=true;  //disable send button
  let inps=document.getElementsByTagName('input');
  for (let inp of inps) if (inp.type=='text') inp.disabled=true;  //disable all input fields
  
  let trs=document.getElementsByTagName('tr');
  for (let tr of trs) {
    ind=tr.firstChild;
    if (!ind.firstChild) continue;  //skip th row
    ind.className='abort';
    let pbd=document.createElement('div');
    pbd.className='pb';
    let pbs=document.createElement('span');
    pbs.id='pb_'+tr.id.substr(4);
    pbs.textContent='...';
    let pb=document.createElement('progress');
    pbd.appendChild(pbs);
    pbd.appendChild(pb);
    ind.nextSibling.nextSibling.appendChild(pbd);
  }
  document.getElementsByTagName('body')[0].scrollIntoView(
    { block: 'start', inline: 'nearest', behavior: 'smooth'} );
}

async function cancel(e) {
debug('cancel clicked');
  if (sending) {
    msgs.forEach(msg=>{ 
      if (msg.sending) {
debug('abort '+msg.id+' '+msg.subject);
        messenger.smr.abort(wid, Number(msg.id));
      }
    });
  } else {  //its close
		removeWin();
  }
}

function removeMsg(ev) {
  let tr=ev.target.parentNode;
  let msgId=tr.id.substr(4);
  if (!sending) {
debug('remove message '+msgId);
    msgs.splice(msgs.findIndex(msg=>msg.id==msgId), 1);
    tr.parentNode.removeChild(tr);
    msgCount=msgs.length;
    if (!msgs.length) cancel();
  } else {
debug('abort message '+msgId);
    messenger.smr.abort(wid, Number(msgId));
  }
}

async function openAB() {
debug('openAB: cb_exists returns '+await messenger.smr.cb_exists());
	if (await messenger.smr.cb_exists())
		messenger.smr.cb_open();
	else
		messenger.addressBooks.openUI();
}

let listener=function(data) {
debug('onMailSent fired: '+JSON.stringify(data));
  if (data.type=='copied') {  //only on test
    let pbs=document.getElementById('pb_'+data.msgid);
    let size=(Number(data.size)/1000./1000.).toFixed(2);
    size=size+'MB';
    pbs.textContent=size;
  } else if (data.type=='started') {
    let pbs=document.getElementById('pb_'+data.msgid);
    let size=(Number(data.size)/1000./1000.).toFixed(2);
    size=size+'MB';
    pbs.textContent=size;
  } else if (data.type=='finished' || data.type=='aborted') {
    let msg=msgs.find(msg=>msg.id==data.msgid);
    msg.sending=false;
    let tr=document.getElementById('msg_'+data.msgid);
    tr.firstChild.nextSibling.nextSibling.innerHTML='';
    tr.firstChild.removeEventListener('click', removeMsg);
    if (data.state==0) {
      tr.style.color='green';
      tr.firstChild.className='ok';
    } else {
      tr.style.color='red';
      tr.firstChild.className='failed';
    }
    msgCount--;
    if (!msgCount) {
      sending=false;
      document.getElementById("addressCANCEL").value=messenger.i18n.getMessage('close');
    }
  }
}

async function load() {
  wid=(await messenger.windows.getCurrent()).id;
  prefs=await messenger.storage.local.get({debug: false});
    //dont use storage.local.get() (without arg), see https://thunderbird.topicbox.com/groups/addons/T46e96308f41c0de1
debug('load: wid='+wid+' debug='+prefs.debug);

  if (messenger.smr.onMailSent.hasListener(listener)) {
debug('we already have a listener');
  }
  messenger.smr.onMailSent.addListener(listener, wid);

  if (!('debug' in prefs)) prefs.debug=false;
	document.getElementById("addressCANCEL").addEventListener('click', cancel);
	document.getElementById("addressOK").addEventListener('click', send);
	document.getElementById("addresses").addEventListener('keydown', okAndInput);
	document.getElementById("addresses").addEventListener('drop', drop);
	document.getElementById("addresses").addEventListener('input', search);
//	document.getElementById("ab").addEventListener('click', ()=>messenger.addressBooks.openUI());
	document.getElementById("ab").addEventListener('click', openAB);

	msgs = await messenger.runtime.sendMessage({action: "requestData", prefs: prefs});
  let mails=document.getElementById("mails");
  let tbody=mails.firstChild;
  if (tbody.tagName!='tbody') tbody=tbody.nextSibling;
	msgs.forEach(msg=>{ 
    msg.sending=false;
    let d=new Date(msg.date);
    let date=d.toLocaleString();
    let tr=document.createElement('tr');
    tr.id="msg_"+msg.id;
    let td=document.createElement('td');
    td.textContent=' ';
    td.className="remove";
    td.addEventListener('click', removeMsg);
    tr.appendChild(td);
    td=document.createElement('td');
    td.textContent=msg.subject;
    tr.appendChild(td);
    td=document.createElement('td');  //progressbar
    td.className='pb';
    tr.appendChild(td);
    td=document.createElement('td');
    td.textContent=msg.author;
    tr.appendChild(td);
    td=document.createElement('td');
    td.textContent=date;
    tr.appendChild(td);
    tbody.appendChild(tr);
  });

	document.getElementById("body").style.display = "block";
	document.getElementById("addresses").focus();

}
async function search(ev) {
  let sel=document.getElementById('results');
  validate(ev.target)
  if (ev.target.value.length<2) {
    if (sel) sel.style.display='none';
    return;
  }
	let addresses=[];
	let cb=await messenger.smr.cb_exists();
debug('cardBook exists: '+cb);
	if (cb)
		addresses=await messenger.smr.cb_search(ev.target.value/*+' @'*/);
	if (!cb || cb>1) {
		let nodes=await messenger.contacts.quickSearch(null, '"'+ev.target.value+'" @');
		nodes.forEach(node=>{
			if (node.properties.PrimaryEmail)
				addresses.push(node.properties.DisplayName?
					'"'+node.properties.DisplayName+'" <'+node.properties.PrimaryEmail+'>':
					node.properties.PrimaryEmail);
			if (node.properties.SecondEmail)
				addresses.push(node.properties.DisplayName?
					'"'+node.properties.DisplayName+'" <'+node.properties.SecondEmail+'>':
					node.properties.SecondEmail);
		});
	}
  addresses = [...new Set(addresses)];  //remove duplicates
debug('found '+addresses.length);
  if (addresses.length && addresses.length<=20) {
    if (sel) {
      while (sel.firstChild) sel.removeChild(sel.lastChild);
      sel.style.display='block';
    } else {
      sel=document.createElement('select');
      sel.id='results';
      sel.multiple=true;
      sel.autocomplete='off';
      sel.addEventListener('keydown', selectitem);
      sel.addEventListener('click', selectitem);
    }
    sel.size=addresses.length<=5?addresses.length:5;
    addresses.forEach(address =>{
      let opt=document.createElement('option');
      opt.textContent=address;
      sel.appendChild(opt);
    });
    ev.target.parentNode.insertBefore(sel, ev.target.nextSibling); //appends if no nextSibling
/*
    let offset=document.getElementById("addresses").offsetTop;
//debug('offset='+offset);
//debug('div.clientHeight='+sel.parentNode.clientHeight+
//'-(input.offsetTop='+sel.previousSibling.offsetTop+
//'+input.offsetHeight='+sel.previousSibling.offsetHeight+
//'+sel.offsetHeight='+sel.offsetHeight+')');
    sel.parentNode.scrollTop = 
      (sel.previousSibling.offsetTop-offset + sel.previousSibling.offsetHeight+sel.offsetHeight)
      - sel.parentNode.clientHeight;
*/
    sel.scrollIntoView(false);
  } else {
    let sel=document.getElementById('results');
    if (sel) sel.style.display='none';
  }
}

function selectitem(ev) {
  if (ev.type == "keydown" && (ev.key == "Enter" || ev.key==" ") || ev.type == 'click') {
    ev.preventDefault();
    let sel=document.getElementById('results');
    let input=sel.previousSibling;
    sel.parentNode.removeChild(sel);
    input.value=ev.target.value;
    validate(input);
    input.focus();
    newInput(input);
  }
}
function drop(ev) {
  let sel=document.getElementById('results');
  if (sel) sel.style.display='none';
  let address = ev.dataTransfer.getData("text");
  debug('dropped '+address);
  if (!ev.target.value) //else its a replace
    newInput(ev.target);
  ev.target.value=address;
  validate(ev.target);
  ev.preventDefault();
}
function newInput(elem) {
  let ni=elem.nextSibling;
//debug('newInput next is '+ni);
  if (!ni) {
    ni=elem.cloneNode(true);
    ni.removeAttribute('id');
    ni.value='';
    ni.className='empty';
    ni.addEventListener('keydown', okAndInput);
    ni.addEventListener('drop', drop);
    ni.addEventListener('input', search);
    elem.parentNode.appendChild(ni);
  }
  ni.focus();
  document.getElementsByTagName('body')[0].scrollIntoView(false);
}

async function removeWin() {
	let win = await messenger.windows.getCurrent();
	let wInfo=await messenger.windows.get(win.id);
	prefs.top=wInfo.top;
	prefs.left=wInfo.left;
  await messenger.storage.local.set(prefs);
	debug('positioned window now at '+prefs.left+'x'+prefs.top);

	await messenger.windows.remove(win.id);	
}

document.addEventListener('DOMContentLoaded', load, { once: true });
// window close is recognized by unregister of onMailSent

let debugcache='';
function debug(txt, force) {
	if (force || prefs) {
		if (force || prefs.debug) {
			if (debugcache) console.log(debugcache); debugcache='';
			console.log('SMR: '+txt);
		}
	} else {
		debugcache+='SMR: '+txt+'\n';
	}
}
